************
Installation
************

.. |logowin| image:: windows_icon.png
    :height: 96px
    :target: `win10_install_notes`_

.. |logolinux| image:: linux_icon.png
    :height: 96px
    :target: `linux_install_notes`_

.. |logomac| image:: apple_icon.png
    :height: 96px
    :target: `mac_install_notes`_



.. admonition:: Select your Operating System to view specific installation instructions

    |logowin| |logolinux| |logomac|


.. _common_install_notes:

In a terminal window, execute the setup program you've just downloaded.

.. code-block:: console

    $ sh ./MsSpec-version.setup

Once the install process has competed, you can launch the MsSpec environnement by typing::

    msspec




.. _win10_install_notes:

For Windows 10
==============

Windows users can install MsSpec through the Windows Subsystem for Linux
(also known as bash Ubuntu).

Below is a short description of the steps to enable this feature. You can
have more details `here <https://docs.microsoft.com/en-us/windows/wsl/install-win10>`_.

Install the Windows Subsystem for Linux
---------------------------------------

1. Turn on Developer Mode
   Open **Settings -> Update and Security -> For developers**

.. figure:: win_step1.png
    :align: center
    :width: 70%

    Select the Developer Mode radio button

2. Open a command prompt. Run::

    bash

.. figure:: win_step2.png
    :align: center
    :width: 70%

    Type "y" to accept the license. An Ubuntu system will be installed.


3. Launch a new Ubuntu shell by running *bash* from the command prompt.
   If this is the first time that the Windows Subsystem for Linux is installed,
   you will be prompted to create a UNIX user. Simply follow the instructions.
   This UNIX username and password may be different from your Windows username 
   and password.

Install an X server
-------------------

To allow graphical windows to popup in this Linux environnement, you need to install
an X server. **Xming** is a good choice. Go to `this website <http://www.straightrunning.com/XmingNotes/>`_
and download and install the public version 6.9.0.31.

Don't forget to start the server after the install. You can configure it to always run automatically at 
the startup.

Install MsSpec
--------------

Open a Windows command prompt and launch *bash*. For the Xming server to work, you need to modify
the DISPLAY environnement variable. Enter this command::

    echo "export DISPLAY=:0" >> ~/.bashrc && source ~/.bashrc

Then you can launch the setup program::

    cd /where/the/setup/program/was/downloaded
    sh ./MsSpec-version.setup

where *version* is the actual version number



.. _linux_install_notes:

For Linux
=========

Ubuntu and Mageia based dstributions are supported by the installer, but any Linux
flavour should be able to run MsSpec as long as you have permissions to install
all requirements.

You just need to open a terminal window and execute the setup program.


.. _mac_install_notes:

For Mac 0S
==========

.. note::
    to be written...
